package io.core.server;

import java.io.*;
import java.net.*;
import java.util.Vector;

import io.core.messaging.IOTheater;
import io.core.messaging.TheaterLocator;

public class ServerHandler extends Thread {

	private TheaterLocator location;
	private Vector serverList;
	private int maxPeerConnections;

	public ServerHandler(Vector _serverList, int _maxPeerConnections, TheaterLocator _location) {
		serverList = _serverList;
		maxPeerConnections = _maxPeerConnections;
		location = _location;
	}

	public void run () {
		for (int i = 0; i < serverList.size(); i++) {
        	        try {
				URL serverLocation = new URL((String)serverList.get(i));

	                        //Connect to the given Server;
				Socket serverConnection = new Socket(serverLocation.getHost(), serverLocation.getPort());
				ObjectOutputStream out = new ObjectOutputStream(new BufferedOutputStream(serverConnection.getOutputStream()));
				
				//First we write the maximum number of Peer's we want to connect to
				//then we write our current location,  and close the connection
				out.writeObject(new Integer(maxPeerConnections / serverList.size()));
	                        out.writeObject(location);
	                        out.flush();
	                        out.close();
	                        serverConnection.close();  
                        
                	} catch (UnknownHostException e) {
                	        System.err.println("Error sending information to server: "+serverList.get(i)+":"+e);
                	} catch (IOException e) {
                	        System.err.println("Error sending information to server: "+serverList.get(i)+":"+e);
          		}
		}
	}

}
